--wipe.e by Copyright 2008 Robert Gorham robsteeliano@gmail.com 
--     This file is part of Wipe.
--     Wipe is free software: you can redistribute it and/or modify
--     it under the terms of the GNU General Public License as published by
--     the Free Software Foundation, either version 3 of the License, or
--     (at your option) any later version.
--     Wipe is distributed in the hope that it will be useful,
--     but WITHOUT ANY WARRANTY; without even the implied warranty of
--     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--     GNU General Public License for more details.
				
--     You should have received a copy of the GNU General Public License
 --    along with Wipe.  If not, see <http://www.gnu.org/licenses/>.
					
--10/18/08
include file.e
-- Gets the size of a File
-- Input:
--  name    -name of the file
-- Returns:
--  size of file
--  -1 if file doesn't exist
global function GetSize(sequence name)
    object d
    d = dir(name)
    --d is sequence if file exists
    if sequence(d) then
	return d[1][D_SIZE]
    end if
    --return -1 if file isn't found
    return -1
end function

-- Overwrites a file
-- Input:
--  filenum     -filenumber of file to be overwritten
--  size        -size of file to be overwritten
--  chunksize   -size of chunks to write to file
--  val         -byte to write as a chunk

    
global procedure OverWrite(integer filenum, integer size, 
			    integer chunksize, atom val)
    integer bFlag, i
    sequence chunk
    bFlag = 1
    --initialize chunk to write to file
    chunk = repeat(val, chunksize)
    
    --set file pointer to beginning of file
    i = seek(filenum, 0)
    
    while bFlag do
	
	--if the chunk would overwrite outside of file
	--set it equal to size of file - where pointer is
	if (where(filenum) + chunksize) > size then

	    --set bFlag so this is last run of loop
	    bFlag = 0
	    
	    --set chunk as to not overwrite end of file
	    chunk = repeat(val,( size - where(filenum) ) )
	
	end if
	--write the last chunk to file
	puts(filenum, chunk)
    
    end while
end procedure

-- Overwrites file a certain number of repetitions
-- Always overwrites a file at least twice
-- Once with 0's and once with 1's
-- Input:
--  filenum     -filenumber of file to overwrite
--  size        -size of file to overwrite
--  chunksize   -size of chunks of bytes to write
--  rep         -amount of repetitions to go overwrite file

global procedure OverAction(integer filenum, integer size, integer chunksize, 
				integer rep)
    for i = 1 to rep by 1 do
	OverWrite(filenum, size, chunksize, 0)
	OverWrite(filenum, size, chunksize, 1)
    end for
    return
end procedure

