--wipe.ex by Robert Gorham RobSteeliano@gmail.com
--10/21/08
--     This file is part of Wipe.
--     Wipe is free software: you can redistribute it and/or modify
--     it under the terms of the GNU General Public License as published by
--     the Free Software Foundation, either version 3 of the License, or
--     (at your option) any later version.
--     Wipe is distributed in the hope that it will be useful,
--     but WITHOUT ANY WARRANTY; without even the implied warranty of
--     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--     GNU General Public License for more details.
				
--     You should have received a copy of the GNU General Public License
--    along with Wipe.  If not, see <http://www.gnu.org/licenses/>.

include wipe.e
include get.e

--  Constants
--Set chunksize to that of 1 meg
constant CHUNKSIZE = power(2, 20)   --Size in bytes of chunks written to file
constant REPETITION = 1     --How many times should the file be overwritten

--  Get the Filename as a command line Argument
--  Returns:
--   sFile = 3rd Argument of command_line(), which is first arg at after 
--   program name
--   O if there is nothing after program name on commandline
function GetArgs()
    sequence sFile, sCmdLine
    sCmdLine = command_line()
    if length(sCmdLine) < 3 then
	return 0
    end if
    sFile = sCmdLine[3]
    return sFile
end function

-- Checks to see if a program exists by checking it's size
--  Input:
--   sFile  -name of file
--  Returns:
--   0 if file doesn't exist
--   1 if file does exist
function FileExists(sequence sFile)
    --Means that I can't find the file
    if GetSize(sFile) < 0 then
	return 0
    end if
    --Means that i can find the file
    return 1
end function

-- Main Function
procedure main()
    sequence sFile, sDelStr
    integer iTemp, iFileNum, iFileSize
    atom timenow -- for tracking time
    iFileNum = 0
    iFileSize = 0
    iTemp = 0
    timenow = 0
    sFile = {}
    sDelStr = {}
    --Check the length of the commandline to see if there are enough args
    if length( command_line() ) > 2 then
	
	sFile = GetArgs()
	--Check to see if the file exists
	if FileExists(sFile) then
	    
	    --if so grab the File's Size
	    iFileSize = GetSize(sFile)
	    
	    --Grab FileNumber
	    iFileNum = open(sFile, "u")
	    
	    --Overwrite the file with CHUNKSIZE chunks for
	    --REPETITION reps
	    timenow = time()
	    OverAction(iFileNum, iFileSize, CHUNKSIZE, REPETITION)
	    ? time() - timenow
	end if
    else
	--If commandline errors then display usage and return
	puts(1, "\nSyntax wipe FILENAME\n")
	return
	
    end if
    close(iFileNum)
    sDelStr = "del " & sFile
    --System delete file
    system(sDelStr, 2)
end procedure

main()
